%global java_home /usr/lib/jvm/java
%global jarname   rabbitmq-client

%global failjava  true
%global failjunit no
#global failjunit yes


Name:           rabbitmq-java-client
Version:        3.4.1
Release:        1%{?dist}
Summary:        RabbitMQ Java client library

License:        ASL 2.0 and MPLv1.1 and GPLv2+
URL:            http://www.rabbitmq.com/java-client.html
Source0:        http://www.rabbitmq.com/releases/%{name}/v%{version}/%{name}-%{version}.tar.gz

BuildArch:      noarch
BuildRequires:  ant >= 1.6
BuildRequires:  java-devel >= 1.5
BuildRequires:  python >= 2.6
BuildRequires:  python-simplejson
BuildRequires:  apache-commons-cli

# deps for tests
BuildRequires:  ant-junit rabbitmq-server

Requires:       java-headless
Requires:       apache-commons-cli

#Suggests:       rabbitmq-server
#Suggests:       activemq

%description
The library allows Java code to interface to AMQP servers.
Please see the specification page for more information on AMQP
inter-operation and standards-conformance.

The library is open-source, and is dual-licensed under the
Mozilla Public License v1.1 and the GNU General Public License v2.

You will need an AMQP server, such as our very own RabbitMQ server,
to use with the client library.


%package javadoc
Summary:        Javadoc for %{name}
Requires:       javapackages-tools

%description javadoc
API documentation for %{name}.


%prep
%setup -q
# use ant only
rm Makefile lib/*.jar
ln -s %{_javadir}/commons-cli.jar lib
#sed -i 's,\(\"jar.name\" value=\"\).*\",\1%{jarname}\",' build.xml
sed -i 's,\(\"haltOnFailureJunit\" value=\"\).*\",\1%{failjunit}\",' build.xml
sed -i 's,\(\"haltOnFailureJava\" value=\"\).*\",\1%{failjava}\",' build.xml
export JAVA_HOME=%{java_home}


%build
ant jar
ant javadoc


%check
ant test-jar

# client tests need a mock server
export RABBITMQ_LOG_BASE=.
export RABBITMQ_MNESIA_BASE=.
export RABBITMQ_NODENAME=testrabbit
su rabbitmq -c 'rabbitmq-server -detach' &disown

#ant test-suite
#ant -Dtest=testDoubleDeletionExchange test-single
ant test-server
ant test-client
# FIXME functional tests failure ahead!
#ant test-functional
#ant test-functional-and-server-with-ha


%clean
#ant clean
# FIXME assume there's only our test server
su rabbitmq -c 'pgrep -u rabbitmq -f $RABBITMQ_NODENAME |xargs kill' || :


%install
install -d %{buildroot}%{_javadir}
install -m0644 build/lib/%{jarname}.jar %{buildroot}%{_javadir}
install -d %{buildroot}/%{_mavenpomdir}
install -m0644 pom.xml %{buildroot}/%{_mavenpomdir}/JPP-%{jarname}.pom
%add_maven_depmap JPP-%{jarname}.pom %{jarname}.jar
install -d %{buildroot}%{_javadocdir}/%{jarname}
cp -pr build/doc/api/* %{buildroot}%{_javadocdir}/%{jarname}


%files -f .mfiles
%doc LICENSE* README-* doc/*
#%{_javadir}/*.jar

%files javadoc
%doc LICENSE*
%{_javadocdir}/%{jarname}


%changelog
* Tue Nov 25 2014 Raphael Groner <projects.rg [AT] smart.ms> - 3.4.1-1
- initial
